/**
 * @equinor/opt-ui-core v6.22.0
 *
 * Copyright (c) Equinor ASA.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE.md file in the root directory of this source tree.
 *
 * @license MIT
 */import{jsx as P}from"react/jsx-runtime";import H from"clsx";import{isBefore as x,startOfDay as d,isAfter as T,isEqual as J}from"date-fns";import t from"prop-types";import Fe,{useRef as Ge,useState as c,useEffect as ze,useCallback as He}from"react";import Je from"../DatePicker/components/Calendar.js";import{parseDate as S,formatDatePicker as y}from"../DatePicker/utils/helpers.js";import Ke from"../Popover/Popover.js";import"../BaseIcon/BaseIcon.js";import"date-fns/locale/en-US";import"date-fns/locale/nb";import Qe from"../utils/setRef/setRef.js";import{getStyledSystemSpaceProps as K,getStyledSystemTypographyProps as Q,getStyledSystemLayoutProps as Ue,getStyledSystemPositionProps as U,getStyledSystemColorProps as X,getStyledSystemBorderProps as Y,getStyledSystemGridLayoutProps as Xe,getStyledSystemFlexboxProps as Ye,getStyledSystemBackgroundProps as Ze}from"../utils/styledSystemHelpers.js";import et from"../utils/useForkRef/useForkRef.js";import"styled-components";import"color";import tt from"./DateRangePickerInput.js";const E=Fe.forwardRef(function(Z,ee){const{className:te,tooltipRef:oe,nDisplays:I,nInputs:N,separator:ae,allowClear:re,picker:n,value:u,defaultValue:g,format:s,placeholderStartDate:le,placeholderEndDate:ne,showTime:p,showToday:se,showWeekNumber:pe,onChange:f,onChangeOnClickOutside:ie,disabled:k,disabledDates:de,popoverElevation:ue,popoverPlacement:me,popoverStyleProps:i,startDateInputProps:ce,endDateInputProps:fe,footer:ye,...m}=Z,W=Ge(),j=et(W,ee),h=u?S(u[0],s):g?S(g[0],s):"",D=u?S(u[1],s):g?S(g[1],s):"",[he,w]=c(!1),[R,_]=c(h),[a,v]=c(h),[B,L]=c(D),[r,C]=c(D),[V,q]=c(null),[l,O]=c(0),De=I>0?I:2,{...ge}=K(m),{...be}=Q(m),{...Pe}=Ue(m),{...Se}=U(m),{...ke}=X(m),{...we}=Y(m),{...ve}=K(i),{...Ce}=X(i),{...Oe}=Q(i),{...xe}=Xe(i),{...Te}=Ye(i),{...Ee}=Ze(i),{...Ie}=Y(i),{...Ne}=U(i),We=y(n,a,s,p),je=y(n,r,s,p);ze(()=>{v(h),C(D)},[u]);const Re=He(e=>Qe(j,e),[j]),_e=()=>{k||(w(!0),O(1),_(h||a),L(D||r))},M=()=>{k||(w(!0),O(2),_(h||a),L(D||r))},b=()=>{O(0),q(null),w(!1)},Be=(e,o)=>{W.current.contains(o.target)||(f&&ie&&f({text:y(n,R,s,p),date:R||null},{text:y(n,B,s,p),date:B||null}),b())},$=e=>{l===1&&v(e),l===2&&C(e)},Le=e=>{const o=l===1?e:a,z=l===2?e:r;f&&l===2&&f({text:y(n,o,s,p),date:o},{text:y(n,z,s,p),date:z}),$(e),l===1?M():b()},Ve=(e,o)=>{o.preventDefault(),o.stopPropagation(),!u&&(e===-1||e===1)&&v(null),!u&&(e===-1||e===2)&&C(null),f&&f({text:null,date:null},{text:null,date:null}),b()},A=e=>()=>{q(e)},F=e=>{if(l===1&&r){const o=a||e;return x(e,d(r))&&T(e,d(V||o))||J(e,d(r))}return l===2&&a?x(e,d(V||r||e))&&T(e,d(a))||J(e,d(a)):!1},qe=(e,o)=>!o&&a&&n==="week"&&F(e)?"is-range":"",Me=(e,o)=>!o&&n==="week"?{onMouseEnter:A(e)}:{},$e=(e,o)=>!o&&(a||r)&&n!=="week"&&F(e)&&!G(e)?"is-range":"",Ae=(e,o)=>!o&&n!=="week"?{onMouseEnter:A(e),disabled:o||G(e)}:{},G=e=>l===2&&a?x(e,d(a)):l===1&&r?T(e,d(r)):!1;return P(Ke,{tooltipRef:oe,className:H("opt-datepicker","opt-datepicker--range"),arrow:!1,open:he,onClose:b,onClickOutside:Be,content:P(Je,{nDisplays:De,type:n,showToday:se,showTime:p,showWeekNumber:pe,initialDate:l===1?a||null:r||null,onSelectDate:$,onChange:Le,disabledDates:de,rowClassNames:qe,rowProps:Me,cellClassNames:$e,cellProps:Ae,footer:ye}),elevation:ue,placement:me,...ve,...Ce,...Oe,...xe,...Te,...Ee,...Ie,...Ne,children:P("span",{className:H("opt-datepicker__input","opt-datepicker__input--range"),children:P(tt,{ref:Re,className:te,allowClear:re,nInputs:N,focusInput:l,separator:ae,placeholderStartDate:le||"Start date",placeholderEndDate:ne||"End date",startDate:We||"",endDate:je||"",onClickClear:Ve,onClickStartDate:_e,onClickEndDate:M,disabled:k,width:N>1?p?"190px":"135px":p?"300px":"220px",outlineWidth:m.outlineWidth,...ge,...be,...Pe,...Se,...ke,...we,startDateInputProps:ce,endDateInputProps:fe})})})});E.propTypes={tooltipRef:t.object,nDisplays:t.number,nInputs:t.number,separator:t.oneOfType([t.string,t.element]),allowClear:t.bool,picker:t.oneOf(["date","week","month","quarter","year"]),value:t.arrayOf(t.oneOfType([t.string,t.instanceOf(Date)])),defaultValue:t.arrayOf(t.oneOfType([t.string,t.instanceOf(Date)])),format:t.string,placeholderStartDate:t.string,placeholderEndDate:t.string,showTime:t.bool,showToday:t.bool,showWeekNumber:t.bool,onChange:t.func,onChangeOnClickOutside:t.bool,disabled:t.bool,disabledDates:t.func,popoverElevation:t.number,popoverPlacement:t.oneOf(["bottom-end","bottom-start","bottom","left-end","left-start","left","right-end","right-start","right","top-end","top-start","top"]),popoverStyleProps:t.object,startDateInputProps:t.object,endDateInputProps:t.object,footer:t.element},E.defaultProps={nDisplays:2,nInputs:1,separator:"-",allowClear:!0,picker:"date",value:void 0,defaultValue:void 0,format:void 0,placeholderStartDate:void 0,placeholderEndDate:void 0,showTime:!1,showToday:!0,showWeekNumber:!1,onChange:void 0,onChangeOnClickOutside:!0,disabled:!1,disabledDates:void 0,popoverElevation:2,popoverPlacement:"bottom-start",popoverStyleProps:{},startDateInputProps:{},endDateInputProps:{},footer:void 0};export{E as default};
